 ; TSR (368B) do wyczania programw
 ; Hook 09h
 ;
 ; Program wpisuje pod adres: seg_PSP:101h kod zakoczenia procesu.
 ; Kod ten to : nop,nop,...,nop
 ;              mov ax,4c01
 ;              int 21h
 ;              jmp FFFF:0000
 ; Zwalnia pami rodowiska i przesuwa kod 80h do tyu (na PSP)
 ;
 ; KILLPROC alias ASSASSIN
 ;
 ; Added "Remove from memory" option - /U
 ;

.286
 kod segment
 assume cs:kod
 org 100h

 debug_treat macro         ; Macro do oszukiwania odczytw z TD
      cli
      jmp  $+4
           dw  0C766h      ; To treat debugger
 endm

 hot_key    equ 29h         ; "~"
 spec_key   equ 01h         ; L-Ctrl - zmienna 0040:0018
 patch_ofs  equ 101h        ; Warto offset'u gdzie zapisa wyjcie

 haslo      equ 'IRON'
 odzew      equ 'MAID'


begin:             ; ------- Poczatek --------

beg_resi:
 jmp start

 old_ofs09h dw ?            ; Zmienne na stary vector
 old_seg09h dw ?
 i10_ofs    dw ?
 i10_seg    dw ?

 patch_beg:
            mov  ax,4c01h
            int  21h
            db   0eah,00,00,0FFh,0FFh   ; JMP FFFF:0000
; db 0b8h,01h,4ch,0cdh,21h,0eah,00,00,0FFh,0FFh - to samo co ugry
 patch_end:

 tym_es     dw ?
 tym_ax     dw 066FDh       ; Dla zmylenia Debugger'a,  32bitznacznik.
 tym_bx     dw 0c7h         ; MOV 32b,32b



;--------------------------- Interrupt Handler (09h) -------------------------
 int09handler proc far
 push ax
 in   al,60h                ; odczyt z portu klawiatury po znak
 cmp  al,hot_key
 pop  ax
 jz   jest_hot_key
 jmp  oryg                  ; not Hot-Key

 db   0fdh                  ; Dla zmylenia Debugger'a
 dw   0c766h

jest_hot_key:
 push ax
 push es
 push 0000
 pop  es
 mov  al,es:[418h]
 and  al,spec_key
 cmp  al,spec_key
 pop  es
 pop  ax
 jz   kill
 jmp  oryg                  ; Hot-Key ale nie z szarym

kill:
 mov  cs:tym_es,es          ; Zapamitanie ES, BX i AX
 mov  cs:tym_ax,ax
 mov  cs:tym_bx,bx

 call beep                  ; Beeeeep
 mov  al,20h
 out  20h,al                ; EOI

                     ; Pobranie ze stosu adresu powrotu
 pop  ax                    ; IP
 pop  ax                    ; CS
;*) pop  ax                    ; FLAGS
;*) mov  cs:iret_flag,ax       ; Save flags (i don't now what for)

 mov  ah,62h                ; Get current process seg of PSP
 int  21h                   ; Ret: BX - contains seg of PSP

 mov  es,bx
 mov  bx,patch_ofs          ; Pod jakim offset'em wpisywac kod

                      ; Zapis nowego adresu powrotu
;*) push cs:iret_flag          ; Rzucenie flag
 push es                    ; New CS
 push bx                    ; New IP

; *) - cause FLAGS may stay on stack (they has not been changed)
;      Clean economy.

                   ; Zapis kodu na ktory nastapi powrot
 push di
 push si
 push ds
 mov  si,offset patch_beg
 mov  di,bx
 push cs
 pop  ds
 cld
 mov  cx,offset patch_end-offset patch_beg
 rep  movsb
 pop  ds
 pop  si
 pop  di

 mov  bx,cs:tym_bx          ; Przywrcenie poprzednich rejestrw
 mov  ax,cs:tym_ax          ;     (i don't know what for, but...)
 mov  es,cs:tym_es          ; I know what for: Moga by wywoana na
                            ; przerwaniu a nie na programie.
 iret                       ; Let's kill son of a bitch

oryg:
 jmp  [dword ptr old_ofs09h]
 int09handler endp
;------------------------------------------



i10_handler proc far
        cmp   ax,0FFFFh
        jnz   obsluga
.386
        cmp   ebx,haslo              ; Check 4 resident
        jnz   obsluga
        mov   ebx,odzew
        mov   ax,cs                  ; eby wywo moga dotrze do PSP
.286
        jmp   get_lost

obsluga:
        jmp   [dword ptr i10_ofs]    ; Wywo starej proc
get_lost:
        iret
i10_handler endp



 debug_treat
beep:
 cli
 push ax
 mov  al,0b6h
 out  43h,al
 mov  al,0ffh
 out  42h,al
 mov  al,1
 out  42h,al
 in   al,61h
 or   al,3
 out  61h,al

 mov  ax,0ffffh           ; Warto opnienia
delay:
 push ax
 aad
 aam
 aad
 pop  ax
 dec  ax
 or   ax,ax
 jnz  delay

 in   al,61h              ; NoSound
 and  al,11111100b
 out  61h,al
 pop  ax
 sti
ret
end_resi:

param_check:         ; Sprawdza PSP na obecno w parametrach sowa z AX
      xor    cx,cx
      mov    cl,byte ptr cs:[80h]
      mov    bx,81h
powt:
      cmp    word ptr cs:[bx],ax
      jz     znaleziono
      inc    bx
      loop   powt
      clc                              ; Czyci CF co oznacza nie odnalezienie
      ret
znaleziono:
      stc                              ; Ustawia CF e co znaleziono
ret


remove_tsr proc                   ;  uninstall KillProc
      mov  ax,0FFFFh
.386
      mov  ebx,haslo
      int  10h                    ; Hooked func ret in AX her CodeSeg
      cmp  ebx,odzew
      jnz  not_inst
.286
      mov  dx,ax                  ; TSR's code segment

      mov  ax,3509h               ; Get int 09h
      int  21h
      cmp  bx,offset int09handler ; Kto ley na nas ?
      jnz  remove_failed
      mov  bx,es
      cmp  dx,bx
      jnz  remove_failed

      mov  ax,3510h               ; Get int 09h
      int  21h
      cmp  bx,offset i10_handler  ; Kto ley na nas ?
      jnz  remove_failed
      mov  bx,es
      cmp  dx,bx
      jnz  remove_failed

      mov  es,dx                  ; TSR's code segment

      mov  ax,2509h               ; Restore original interrupt
      mov  dx,es:[old_ofs09h]
      mov  ds,es:[old_seg09h]
      int  21h

      mov  ax,2510h               ; Restore original interrupt
      mov  dx,es:[i10_ofs]
      mov  ds,es:[i10_seg]
      int  21h

      mov  ax,es
      add  ax,8                   ; Count TSR's PSP seg
      mov  es,ax
      mov  ah,49h
      int  21h                    ; Free memory

      push cs
      pop  ds
      mov  ah,09h
      mov  dx,offset uninst       ; Uninstalled msg
      int  21h

      mov  ax,4c00h
      int  21h                    ; Uninstalled
not_inst:
      mov  ah,09h                 ; Try to uninstall TSR which is not in memo
      mov  dx,offset notinst
      int  21h

      mov  ax,4c01h
      int  21h                    ; Uninstall failed

remove_failed:
      push cs
      pop  ds
      mov  ah,09h
      mov  dx,offset not_able     ; Kto ley na nas (msg)
      int  21h

      mov  ax,4c01h
      int  21h                    ; Uninstall failed

remove_tsr endp


;------------------------------- M A I N ----------------------------------
start:
; push cs
; pop  ds
 cmp  byte ptr cs:[80h],0      ; PSP's seg:80h = dugo parametrw
 jz   check4rezi
 mov  ax,'U/'                  ; /U - uninstall KillProc
 call param_check
 jz   uninstal
 mov  ax,'u/'
 call param_check
 jz   uninstal

 mov  ah,09h
 mov  dx,offset info1
 int  21h

 mov  ax,4c01h
 int  21h                      ; End of Help part


check4rezi:
 mov  ax,0FFFFh            ; Checking for other copy of Killproc in memo
.386
 mov  ebx,haslo
 int  10h
 cmp  ebx,odzew
 jnz  install
.286
 mov  ah,09h
 mov  dx,offset rezi
 int  21h

 mov  ax,4c01h
 int  21h                  ; Already resident in memo

uninstal:                  ; /U - uninstall KillProc
 call remove_tsr

install:

 mov  ah,09h               ; Text 2 display
 mov  dx,offset run
 int  21h

 debug_treat



 mov  es,cs:[2ch]          ; PSP[2ch] - segment rodowiska
 mov  ah,49h
 int  21h                  ; ...i go zwolnienie

 debug_treat

 mov  si,100h              ; Przesuwanie o $FF-80h w gre
 push cs
 pop  es
 mov  di,080h
 mov  cx,offset end_resi - offset beg_resi
 cld
 rep  movsb

 mov  ax,cs
 sub  ax,8
 mov  ds,ax

 debug_treat

 mov  ax,3509h             ; install 09h, keyboard's
 int  21h
 mov  ds:[old_seg09h],es
 mov  ds:[old_ofs09h],bx

 mov  ax,3510h               ; adres poprzedniej proc.
 int  21h
 mov  ds:[i10_seg],es          ; zapamitanie adresu starej proc
 mov  ds:[i10_ofs],bx

 mov  ax,2509h
 mov  dx,offset int09handler
 int  21h

 mov  ax,2510h               ; ustalenie nowej proc.
 mov  dx,offset i10_handler
 int  21h

 mov  ax,3100h             ; TSR
 mov  dx,offset end_resi+0fh-080h+0ffh
 shr  dx,4
 int  21h


 info1 db 'Killproc v0.999b, 06 Mar 1997, [FREEWARE].',13,10
       db 13,10
       db 'Terminates current process immediately.',13,10
       db 'After kill some program system may hang,',13,10
       db 'so beware, and don''t be angry for that.',13,10
       db 'Treat this as last chance before reboot.',13,10
       db '     -- To kill press [LCtrl+~] --',13,10
       db 13,10
       db '   "Kill, it''s such a friendly word ',13,10
       db '          Seems the only way ',13,10
       db '        For reaching out again."',13,10
       db '                     from MetallicA. ',13,10
       db 13,10
       db '/U - Uninstalls Killproc from memory',13,10
       db 13,10
       db 'by: Piotrek Skowronek',13,10
       db '    piter@adfinem.net',13,10,'$'

 rezi     db 'Killproc already installed.',13,10,'$'
 notinst  db 'Killproc not installed.',13,10,'$'
 not_able db 'Not able to remove Killproc.',13,10
          db 'Other program installed after.',13,10,'$'
 uninst   db 'Killproc removed from memory.',13,10,'$'
 run      db 'Killproc v0.999b, 06 Mar 1997, by Piotrek Skowronek, [FREEWARE]',13,10
          db '     -- To kill press [LCtrl+~] --',13,10,'$'

 koniec:
 kod  ends
 end  begin